diff --git a/bin/cdist-exec-run b/bin/cdist-exec-run
new file mode 100755
index 00000000..d1ba128d
--- /dev/null
+++ b/bin/cdist-exec-run
@@ -0,0 +1,38 @@
+#!/bin/sh
+#
+# 2010-2011 Nico Schottelius (nico-cdist at schottelius.org)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+#
+# Transfer executables
+#
+
+. cdist-config
+
+[ $# -eq 2 ] || __cdist_usage " "
+set -e
+
+export __cdist_target_host="$1"; shift
+export __cdist_exec_dir="$1"; shift
+
+
+# re-create basedir so it's clean
+ssh "root@${__cdist_target_host}" "rm -rf \"${__cdist_remote_cache_exec}\" && mkdir -p \"${__cdist_remote_cache_exec}\""
+
+# FIXME: enable -q as soon as the code is cleaned up
+scp -r "${__cdist_exec_dir}"/* \
+ "root@${__cdist_target_host}:${__cdist_remote_cache_exec}"